import matplotlib.pyplot as plt
import math

###This will be our differential equation. f'(x) = f(x)
def rate_of_change(y):
    return -y+20

final_x_value = 3.0 #We want to approximate until a certain x value
step_size = 0.5 #We will use a step size of 0.5

#The number of approximations will be defined by the above values
num_of_approximations = int(final_x_value / step_size) #We cast this to int to use it in the for loop  

#Our start value will be one in this case
start_value = 40

#We start with empty x and euler values
x_values = []
euler_values = []
dy_by_dx = []

euler_value = start_value #The first euler value is our start value

#We will do a for loop for the number of approximations
for i in range(0,num_of_approximations) :
    x_value  =  i * step_size #The current x value is defined by the iteration and the step size
    x_values.append(x_value) #Append the x value
    euler_values.append(euler_value) #Append the euler value
    change = rate_of_change(euler_value) #Calculate the rate of change
    dy_by_dx.append(change)
    euler_value = euler_value + step_size * change #Apply the change * stepsize to the old value

plt.plot(x_values,euler_values) #In the end plot x vs euler_values
plt.show()

plt.plot(euler_values,dy_by_dx,linestyle = "-", marker="o")
plt.show()
